; Demonstrates how to use the ButtonEx controls And $custom skin modification

Global $Use64BitProGUI = False	; Use 64bit version of ProGUI (True/False)
#include <ProGUI_AutoIt.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>
Func WindowWidth($hWnd)
    $rc = _WinAPI_GetClientRect($hWnd)
    Return DllStructGetData($rc, "right")-DllStructGetData($rc, "left")
EndFunc

Func WindowHeight($hWnd)
    $rc = _WinAPI_GetClientRect($hWnd)
    Return DllStructGetData($rc, "bottom")-DllStructGetData($rc, "top")
EndFunc


StartProGUI("", 0, 0, 0, 0, 0, 0, 0)




;- Menu/Button Command Constants
Enum $Command_Button1 = 4, $Command_Button2, $Command_Button3, $Command_Button4, $Command_Button5, $Command_Button6, $Command_Button7, $Command_Button8, $Command_Button9, $Command_Button10, $Command_Button11, $Command_Button12

; Define some global arrays for easy access of icon images
Global $imageNormal[6]
Global $imageHot[6]
Global $imageDisabled[6]
Global $imagePressed[6]

; load in some example icons
$imagenormal[0] = LoadImg("icons\shell32_235.ico", 16, 16, 0)
$imagehot[0] = ImgBlend($imagenormal[0], 255, 30, 0, 0, 0, 0)
$imagepressed[0] = ImgBlend($imagenormal[0], 255, 0, -30, 0, 0, 0)
$imagenormal[1] = ImgBlend(LoadImg("icons\newlogo2_256x256.png", 256, 256, 0), 100, 0, 0, 0, 0, $ImgBlend_DestroyOriginal)
$imagenormal[2] = LoadImg("icons\dccmanager\downloadpanel_border.png", 0, 0, 0)
$imagenormal[3] = LoadImg("icons\advanced.ico", 32, 32, 0)
$imagehot[3] = ImgBlend($imagenormal[3], 255, 30, 0, 0, 0, 0)
$imagepressed[3] = ImgBlend($imagenormal[3], 255, 0, -30, 0, 0, 0)
$imagenormal[4] = LoadImg("icons\color.ico", 32, 32, 0)
$imagehot[4] = ImgBlend($imagenormal[4], 255, 30, 0, 0, 0, 0)
$imagepressed[4] = ImgBlend($imagenormal[4], 255, 0, -30, 0, 0, 0)

;- process ProGUI Windows event messages here
Func ProGUI_EventCallback($hwnd, $message, $wParam, $lParam)

  Select

    ; handle selection of menu items And $buttons
    Case $message = $WM_COMMAND

      If HWord($wParam) = 0 Then ; is an ID Then

        $MenuID = LWord($wParam)

        ; tint the default button skin with a random colour!
        If $MenuID = $Command_Button12 Then

          $r = Random(255)
          $g = Random(255)
          $b = Random(255)
          $skin = GetButtonExSkin($Command_Button1)
          SetSkinProperty($skin, "buttonex", "normal", "overlay", "rgba("&$r&", "&$g&", "&$b&", 80)")
          SetSkinProperty($skin, "buttonex", "hot", "overlay", "rgba("&$r&", "&$g&", "&$b&", 80)")
          SetSkinProperty($skin, "buttonex", "pressed", "overlay", "rgba("&$r&", "&$g&", "&$b&", 80)")

        ; ConsoleWrite($output the button ID&@CRLF)
        Else

          ConsoleWrite($MenuID&@CRLF)

        EndIf

      EndIf

    ; resize panelex when main window resized
    Case $message = $WM_SIZE

      _WinAPI_MoveWindow(PanelExID(0, -1), 0, 0, WindowWidth($Window_0), WindowHeight($Window_0), True)

  EndSelect

  Return $GUI_RUNDEFMSG

EndFunc

; creates a window
Func Open_Window_0()

  Global $Window_0 = GUICreate("Button Example: Resize the main window!", 700, 500, -1, -1, BitOR($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX))

  ;- Create PanelEx as main window content
  CreatePanelEx(0, $Window_0, 0, 0, WindowWidth($Window_0), WindowHeight($Window_0), 0)
  $page = AddPanelExImagePage(2, $imagenormal[1], 0, 0, 0, 0, BitOR($PNLX_CENTRE, $PNLX_VCENTRE))
  SetPanelExPageBorder(0, 0, $imagenormal[2], -1, 0, 0)
  SetPanelExPageScrolling(0, 0, $PNLX_AUTOSCROLL, True)

  ;- Create a big button
  ButtonEx($page, $Command_Button1, 50, 50, 200, 100, "A Great Big Button!", 0, 0, 0, 0, 0)

  ;- Create a button with icon
  ButtonEx($page, $Command_Button2, 50, 160, 160, 32, "Button and Icon", $imagenormal[0], $imagehot[0], $imagepressed[0], 0, 0)

  ;- Create a $semi-$transparent button!
  $button = ButtonEx($page, $Command_Button3, 50, 202, 160, 60, "Semi-Transparent!", $imagenormal[0], $imagehot[0], $imagepressed[0], 0, 0)
  ; Because the ButtonEx is really a subclassed PanelEx with $user-$callback
  ; we can use the normal PanelEx commands on it's handle And $change the alpha transparency! :D
  SetPanelExPageAlpha($button, 0, 100, 0)

  ;- Create a button with modified skin
  ; copy system default skin of ButtonEx
  $newSkin = CopySkin(GetButtonExSkin($Command_Button1))
  ; make position of icon for normal state left aligned
  SetSkinProperty($newSkin, "buttonex", "normal", "image position", "x: 0; y: centre")
  ; add a background image for hot state
  SetSkinProperty($newSkin, "buttonex", "hot", "background image", "icons\stop.ico")
  ; make the background tile
  SetSkinProperty($newSkin, "buttonex", "hot", "background position", "tile: true")
  ; make text red for hot state And $change font And $make it bigger (with bold And $strikethrough effect)
  SetSkinProperty($newSkin, "buttonex", "hot", "text", "colour: red; font: Verdana, 11, bold, strike")
  ; change mouse cursor for hot state
  SetSkinProperty($newSkin, "buttonex", "hot", "cursor", "hand")
  ButtonEx($page, $Command_Button4, 400, 50, 200, 64, "Modified Button Skin", $imagenormal[0], $imagehot[0], $imagepressed[0], 0, $newSkin)

  ;- Create a toggle button
  ToggleButtonEx($page, $Command_Button5, 50, 282, 160, 60, "Toggle Button", $imagenormal[3], $imagehot[3], $imagepressed[3], $imagenormal[4], $imagehot[4], $imagepressed[4], 0, 0)

  ;- Create a sticky toggle button
  ToggleButtonEx($page, $Command_Button6, 50, 352, 160, 60, "Sticky Toggle", $imagenormal[3], $imagehot[3], $imagepressed[3], $imagenormal[4], $imagehot[4], $imagepressed[4], 0, $BUTTONEX_STICKYSKIN)

  ;- Create check box button
  $button = CheckButtonEx($page, $Command_Button7, 500, 150, 100, 20, "Check Box", 0)

  ;- Create some radio buttons
  RadioButtonEx($page, $Command_Button8, 500, 200, 120, 20, "Radio Button 1", 0)
  RadioButtonEx($page, $Command_Button9, 500, 230, 120, 20, "Radio Button 2", 0)
  RadioButtonEx($page, $Command_Button10, 500, 260, 120, 20, "Radio Button 3", 0)
  RadioButtonEx($page, $Command_Button11, 500, 290, 120, 20, "Radio Button 4", 0)

  ;- Create an image button that will tint the system default button skin with a random colour when clicked
  ImageButtonEx($page, $Command_Button12, 500, 360, 0, 0, $imagenormal[4], $imagehot[4], $imagepressed[4], 0)
  ; create a nice tooltip for the image button
  ButtonExToolTip($Command_Button12, "Tint the default button skin with a random colour!")

  ; attach our events callback for processing Windows ProGUI messages
  GUIRegisterMsg($WM_COMMAND, "ProGUI_EventCallback")
GUIRegisterMsg($WM_SIZE, "ProGUI_EventCallback")
GUIRegisterMsg($REBAR_UPDATED, "ProGUI_EventCallback")
GUIRegisterMsg($TCX_LINK_CLICK, "ProGUI_EventCallback")
GUIRegisterMsg($TCX_LINK_HOVER, "ProGUI_EventCallback")

EndFunc


Open_Window_0() ; create window
GUISetState(@SW_SHOW) ; show our newly created window


; enter main event loop
Do

  $Event = GUIGetMsg()

Until $Event = $GUI_EVENT_CLOSE

