; Demonstrates how to use ExplorerBars

Global $Use64BitProGUI = False	; Use 64bit version of ProGUI (True/False)
#include <ProGUI_AutoIt.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>

Func WindowHeight($hWnd)
    $rc = _WinAPI_GetClientRect($hWnd)
    Return DllStructGetData($rc, "bottom")-DllStructGetData($rc, "top")
EndFunc

Func WindowWidth($hWnd)
    $rc = _WinAPI_GetClientRect($hWnd)
    Return DllStructGetData($rc, "right")-DllStructGetData($rc, "left")
EndFunc


StartProGUI("", 0, 0, 0, 0, 0, 0, 0)


;- Control Constants
Enum $ExplorerBar

; Define some global arrays for easy access of icon images
Global $imageNormal[8]
Global $imageHot[8]
Global $imageDisabled[8]

; load in some example icons
$imagenormal[0] = LoadImg("icons\shell32_1007.ico", 16, 16, 0)
$imagenormal[1] = LoadImg("icons\shell32_271.ico", 16, 16, 0)
$imagenormal[2] = LoadImg("icons\shell32_22.ico", 16, 16, 0)
$imagenormal[3] = LoadImg("icons\shell32_18.ico", 16, 16, 0)
$imagenormal[4] = LoadImg("icons\shell32_235.ico", 16, 16, 0)
$imagenormal[5] = LoadImg("icons\shell32_4.ico", 16, 16, 0)
$imagenormal[6] = LoadImg("icons\shell32_4.ico", 96, 96, 0)

;- process ProGUI Windows event messages here
Func ProGUI_EventCallback($hwnd, $message, $wParam, $lParam)

  Select

    ; handle selection of menu items And $buttons
    Case $message = $WM_COMMAND

      If Hword($wParam) = 0 Then ; is an ID Then

        $MenuID = LWord($wParam)

        ConsoleWrite($MenuID&@CRLF)

      EndIf

    ; resize panelex And $textcontrolex when main window resized
    Case $message = $WM_SIZE

      _WinAPI_MoveWindow(ExplorerBarID($ExplorerBar), 5, 5, 210, WindowHeight($Window_0)-10, True)
      _WinAPI_MoveWindow(PanelExID(0, -1), 215, 5, WindowWidth($Window_0)-220, WindowHeight($Window_0)-10, True)

  EndSelect

  Return $GUI_RUNDEFMSG

EndFunc

; creates a window
Func Open_Window_0()

  Global $Window_0 = GUICreate("ExplorerBar Example", 700, 500, -1, -1, BitOR($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX))

  ; create our ExplorerBar
  CreateExplorerBar($Window_0, $ExplorerBar, 5, 5, 210, 490, 0)
  AddExplorerBarGroup("System Tasks")
    ExplorerBarImageItem(0, "View system information", $imagenormal[0], 0, 0, 0)
    ExplorerBarImageItem(1, "Add or remove programs", $imagenormal[1], 0, 0, 0)
    ExplorerBarImageItem(9, "Change a setting", $imagenormal[2], 0, 0, 0)
  AddExplorerBarGroup("Other Places")
    ExplorerBarImageItem(3, "My Network Places", $imagenormal[3], 0, 0, 0)
    ExplorerBarImageItem(4, "My Documents", $imagenormal[4], 0, 0, 0)
    ExplorerBarImageItem(5, "Shared Documents", $imagenormal[5], 0, 0, 0)
    ExplorerBarImageItem(6, "Control Panel", $imagenormal[2], 0, 0, 0)
  AddExplorerBarGroup("Details")
    ExplorerBarItem(7, "Example Item 1")
    ExplorerBarItem(8, "Example Item 2")

  ; create PanelEx as main window content
  CreatePanelEx(0, $Window_0, 215, 5, 480, 490, 0)
  AddPanelExImagePage(2, $imagenormal[6], 0, 0, 0, 0, BitOR($PNLX_CENTRE, $PNLX_VCENTRE))

  ; attach our events callback for processing Windows ProGUI messages
  GUIRegisterMsg($WM_COMMAND, "ProGUI_EventCallback")
  GUIRegisterMsg($WM_SIZE, "ProGUI_EventCallback")
  GUIRegisterMsg($REBAR_UPDATED, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_CLICK, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_HOVER, "ProGUI_EventCallback")

EndFunc


Open_Window_0() ; create window
GUISetState(@SW_SHOW) ; show our newly created window

; enter main event loop
Do

  $Event = GUIGetMsg()

Until $Event = $GUI_EVENT_CLOSE

