; Demonstrates multiple menus with different styles in container gadgets on same window

Global $Use64BitProGUI = False	; Use 64bit version of ProGUI (True/False)
#include <ProGUI_AutoIt.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>
StartProGUI("", 0, 0, 0, 0, 0, 0, 0)


;- Control Constants
Enum $MENU_0, $MENU_1, $MENU_2, $MENU_3, $MENU_4, $MENU_5, $MENU_6, $MENU_7, $MENU_8, $MENU_9

; Define some global arrays for easy access of icon images
Global $imageNormal[36]
Global $imageHot[36]
Global $imageDisabled[36]

; load in some example icons
$imagenormal[0] = LoadImg("icons\cut.ico", 16, 16, 0)
$imagehot[0] = LoadImg("icons\cut_h.ico", 16, 16, 0)
$imagedisabled[0] = LoadImg("icons\cut_d.ico", 16, 16, 0)

$imagenormal[1] = LoadImg("icons\paste.ico", 16, 16, 0)
$imagehot[1] = LoadImg("icons\paste_h.ico", 16, 16, 0)
$imagedisabled[1] = LoadImg("icons\paste_d.ico", 16, 16, 0)

$imagenormal[2] = LoadImg("icons\image.ico", 16, 16, 0)
$imagehot[2] = LoadImg("icons\image_h.ico", 16, 16, 0)
$imagedisabled[2] = LoadImg("icons\image_d.ico", 16, 16, 0)

$imagenormal[3] = LoadImg("icons\multimedia.ico", 16, 16, 0)
$imagehot[3] = LoadImg("icons\multimedia_h.ico", 16, 16, 0)
$imagedisabled[3] = LoadImg("icons\multimedia_d.ico", 16, 16, 0)

$imagenormal[4] = LoadImg("icons\package.ico", 16, 16, 0)
$imagehot[4] = LoadImg("icons\package_h.ico", 16, 16, 0)
$imagedisabled[4] = LoadImg("icons\package_d.ico", 16, 16, 0)

$imagenormal[5] = LoadImg("icons\preferences.ico", 16, 16, 0)
$imagehot[5] = LoadImg("icons\preferences_h.ico", 16, 16, 0)
$imagedisabled[5] = LoadImg("icons\preferences_d.ico", 16, 16, 0)

$imagenormal[6] = LoadImg("icons\jump.ico", 16, 16, 0)
$imagehot[6] = LoadImg("icons\jump_h.ico", 16, 16, 0)
$imagedisabled[6] = LoadImg("icons\jump_d.ico", 16, 16, 0)

$imagenormal[19] = LoadImg("icons\copy doc.ico", 32, 32, 0)
$imagehot[19] = LoadImg("icons\copy doc_h.ico", 32, 32, 0)
$imagedisabled[19] = LoadImg("icons\copy doc_d.ico", 32, 32, 0)

$imagenormal[20] = LoadImg("icons\computer on.ico", 32, 32, 0)
$imagehot[20] = LoadImg("icons\computer on_h.ico", 32, 32, 0)
$imagedisabled[20] = LoadImg("icons\computer on_d.ico", 32, 32, 0)

$imagenormal[21] = LoadImg("icons\search.ico", 32, 32, 0)
$imagehot[21] = LoadImg("icons\search_h.ico", 32, 32, 0)
$imagedisabled[21] = LoadImg("icons\search_d.ico", 32, 32, 0)

;- process ProGUI Windows event messages here
Func ProGUI_EventCallback($hwnd, $message, $wParam, $lParam)

  Select

    ; handle selection of menu items
    Case $message = $WM_COMMAND

      If Hword($wParam) = 0 Then ; is an ID Then

        $MenuID = LWord($wParam)

        ConsoleWrite($MenuID&@CRLF) ; display selected menu item

      EndIf

  EndSelect

  Return $GUI_RUNDEFMSG

EndFunc

; creates a window
Func Open_Window_0()

  $Window_0 = GUICreate("MenuExample 2: Multiple menus attached to PureBasic Container Gadgets", 800, 500, -1, -1, BitOR($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX))

  SetMenuExImageSize(16, 16)

  ; sub menu
  CreatePopupMenuEx($MENU_1, $UISTYLE_WHIDBEY)
  MenuItemEx(0, "Submenu 0", $imagenormal[6], $imagehot[6], $imagedisabled[6], 0)

  CreatePopupMenuEx($MENU_7, $UISTYLE_BUTTON)
  MenuItemEx(0, "Submenu 1", $imagenormal[6], $imagehot[6], $imagedisabled[6], 0)

  CreatePopupMenuEx($MENU_8, $UISTYLE_OFFICE2003)
  MenuItemEx(0, "Submenu 2", $imagenormal[6], $imagehot[6], $imagedisabled[6], 0)

  ; main menu
  CreateMenuEx($MENU_0, $Window_0, $UISTYLE_WHIDBEY)
  MenuTitleEx("Title &1")
  MenuItemEx(1, "&Item 1$\bCtrl+C", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
  MenuItemEx(20, "Item &2", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
  MenuTitleEx("Title &2")
  MenuItemEx(3, "&Item 3", $imagenormal[1], $imagehot[1], $imagedisabled[1], MenuExID($MENU_1))
  MenuItemEx(4, "Item &4$\bCtrl+S", $imagenormal[2], $imagehot[2], $imagedisabled[2], 0)
  MenuItemEx(11, "Item &11 (no icon)", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(5, "&\i\c0000a0&Item 5\n$\bCtrl+B", $imagenormal[3], $imagehot[3], $imagedisabled[3], 0)
  MenuTitleEx("Title &3")
  MenuItemEx(6, "&Item 6", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
  MenuItemEx(7, "Item &7", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)
  SetMenuExImageSize(32, 32)
  MenuTitleEx("&Big Icons")
  MenuItemEx(8, "&Item 8", $imagenormal[19], $imagehot[19], $imagedisabled[19], 0)
  MenuItemEx(9, "Item &9$\bCtrl+B", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
  MenuItemEx(10, "Item &10", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)


  CreatePanelEx(0, $Window_0, 100, 200, 300, 50, 0)
 $pageHwnd = AddPanelExPage(1)
    SetMenuExImageSize(16, 16)
    CreateMenuEx($MENU_6, $pageHwnd, $UISTYLE_EXPLORER)
    MenuTitleEx("Title &1")
    MenuItemEx(1, "&Item 1$\bCtrl+C", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuItemEx(20, "Item &2", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuTitleEx("Title &2")
    MenuItemEx(3, "&Item 3", $imagenormal[1], $imagehot[1], $imagedisabled[1], MenuExID($MENU_1))
    MenuItemEx(4, "Item &4$\bCtrl+S", $imagenormal[2], $imagehot[2], $imagedisabled[2], 0)
    MenuItemEx(11, "Item &11 (no icon)", 0, 0, 0, 0)
    MenuBarEx()
    MenuItemEx(5, "&\i\c0000a0&Item 5\n$\bCtrl+B", $imagenormal[3], $imagehot[3], $imagedisabled[3], 0)
    MenuTitleEx("Title &3")
    MenuItemEx(6, "&Item 6", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
    MenuItemEx(7, "Item &7", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)
    SetMenuExImageSize(32, 32)
    MenuTitleEx("&Big Icons")
    MenuItemEx(8, "&Item 8", $imagenormal[19], $imagehot[19], $imagedisabled[19], 0)
    MenuItemEx(9, "Item &9$\bCtrl+B", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
    MenuItemEx(10, "Item &10", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  CreatePanelEx(1, $Window_0, 100, 300, 300, 50, 0)
 $pageHwnd = AddPanelExPage(1)
    SetMenuExImageSize(16, 16)
    CreateMenuEx($MENU_2, $pageHwnd, $UISTYLE_MOZILLA)
    MenuTitleEx("Title &1")
    MenuItemEx(1, "&Item 1$\bCtrl+C", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuItemEx(20, "Item &2", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuTitleEx("Title &2")
    MenuItemEx(3, "&Item 3", $imagenormal[1], $imagehot[1], $imagedisabled[1], MenuExID($MENU_1))
    MenuItemEx(4, "Item &4$\bCtrl+S", $imagenormal[2], $imagehot[2], $imagedisabled[2], 0)
    MenuItemEx(11, "Item &11 (no icon)", 0, 0, 0, 0)
    MenuBarEx()
    MenuItemEx(5, "&\i\c0000a0&Item 5\n$\bCtrl+B", $imagenormal[3], $imagehot[3], $imagedisabled[3], 0)
    MenuTitleEx("Title &3")
    MenuItemEx(6, "&Item 6", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
    MenuItemEx(7, "Item &7", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)
    SetMenuExImageSize(32, 32)
    MenuTitleEx("&Big Icons")
    MenuItemEx(8, "&Item 8", $imagenormal[19], $imagehot[19], $imagedisabled[19], 0)
    MenuItemEx(9, "Item &9$\bCtrl+B", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
    MenuItemEx(10, "Item &10", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  CreatePanelEx(2, $Window_0, 200, 400, 300, 50, 0)
 $pageHwnd = AddPanelExPage(1)
    SetMenuExImageSize(16, 16)
    CreateMenuEx($MENU_3, $pageHwnd, $UISTYLE_BEVELED_A)
    MenuTitleEx("Title &1")
    MenuItemEx(1, "&Item 1$\bCtrl+C", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuItemEx(20, "Item &2", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuTitleEx("Title &2")
    MenuItemEx(3, "&Item 3", $imagenormal[1], $imagehot[1], $imagedisabled[1], MenuExID($MENU_1))
    MenuItemEx(4, "Item &4$\bCtrl+S", $imagenormal[2], $imagehot[2], $imagedisabled[2], 0)
    MenuItemEx(11, "Item &11 (no icon)", 0, 0, 0, 0)
    MenuBarEx()
    MenuItemEx(5, "&\i\c0000a0&Item 5\n$\bCtrl+B", $imagenormal[3], $imagehot[3], $imagedisabled[3], 0)
    MenuTitleEx("Title &3")
    MenuItemEx(6, "&Item 6", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
    MenuItemEx(7, "Item &7", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)
    SetMenuExImageSize(32, 32)
    MenuTitleEx("&Big Icons")
    MenuItemEx(8, "&Item 8", $imagenormal[19], $imagehot[19], $imagedisabled[19], 0)
    MenuItemEx(9, "Item &9$\bCtrl+B", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
    MenuItemEx(10, "Item &10", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  CreatePanelEx(3, $Window_0, 300, 50, 300, 50, 0)
 $pageHwnd = AddPanelExPage(1)
    SetMenuExImageSize(16, 16)
    CreateMenuEx($MENU_4, $pageHwnd, $UISTYLE_OFFICE2003)
    MenuTitleEx("Title &1")
    MenuItemEx(1, "&Item 1$\bCtrl+C", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuItemEx(20, "Item &2", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuTitleEx("Title &2")
    MenuItemEx(3, "&Item 3", $imagenormal[1], $imagehot[1], $imagedisabled[1], MenuExID($MENU_1))
    MenuItemEx(4, "Item &4$\bCtrl+S", $imagenormal[2], $imagehot[2], $imagedisabled[2], 0)
    MenuItemEx(11, "Item &11 (no icon)", 0, 0, 0, 0)
    MenuBarEx()
    MenuItemEx(5, "&\i\c0000a0&Item 5\n$\bCtrl+B", $imagenormal[3], $imagehot[3], $imagedisabled[3], 0)
    MenuTitleEx("Title &3")
    MenuItemEx(6, "&Item 6", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
    MenuItemEx(7, "Item &7", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)
    SetMenuExImageSize(32, 32)
    MenuTitleEx("&Big Icons")
    MenuItemEx(8, "&Item 8", $imagenormal[19], $imagehot[19], $imagedisabled[19], 0)
    MenuItemEx(9, "Item &9$\bCtrl+B", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
    MenuItemEx(10, "Item &10", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  CreatePanelEx(4, $Window_0, 450, 200, 300, 50, 0)
 $pageHwnd = AddPanelExPage(1)
    SetMenuExImageSize(16, 16)
    CreateMenuEx($MENU_9, $pageHwnd, $UISTYLE_OFFICE2007)
    MenuTitleEx("Title &1")
    MenuItemEx(1, "&Item 1$\bCtrl+C", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuItemEx(20, "Item &2", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuTitleEx("Title &2")
    MenuItemEx(3, "&Item 3", $imagenormal[1], $imagehot[1], $imagedisabled[1], MenuExID($MENU_1))
    MenuItemEx(4, "Item &4$\bCtrl+S", $imagenormal[2], $imagehot[2], $imagedisabled[2], 0)
    MenuItemEx(11, "Item &11 (no icon)", 0, 0, 0, 0)
    MenuBarEx()
    MenuItemEx(5, "&\i\c0000a0&Item 5\n$\bCtrl+B", $imagenormal[3], $imagehot[3], $imagedisabled[3], 0)
    MenuTitleEx("Title &3")
    MenuItemEx(6, "&Item 6", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
    MenuItemEx(7, "Item &7", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)
    SetMenuExImageSize(32, 32)
    MenuTitleEx("&Big Icons")
    MenuItemEx(8, "&Item 8", $imagenormal[19], $imagehot[19], $imagedisabled[19], 0)
    MenuItemEx(9, "Item &9$\bCtrl+B", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
    MenuItemEx(10, "Item &10", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  CreatePanelEx(5, $Window_0, 200, 120, 300, 50, 0)
 $pageHwnd = AddPanelExPage(1)
    SetMenuExImageSize(16, 16)
    CreateMenuEx($MENU_5, $pageHwnd, $UISTYLE_BUTTON)
    MenuTitleEx("Title &1")
    MenuItemEx(1, "&Item 1$\bCtrl+C", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuItemEx(20, "Item &2", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
    MenuTitleEx("Title &2")
    MenuItemEx(3, "&Item 3", $imagenormal[1], $imagehot[1], $imagedisabled[1], MenuExID($MENU_1))
    MenuItemEx(4, "Item &4$\bCtrl+S", $imagenormal[2], $imagehot[2], $imagedisabled[2], 0)
    MenuItemEx(11, "Item &11 (no icon)", 0, 0, 0, 0)
    MenuBarEx()
    MenuItemEx(5, "&\i\c0000a0&Item 5\n$\bCtrl+B", $imagenormal[3], $imagehot[3], $imagedisabled[3], 0)
    MenuTitleEx("Title &3")
    MenuItemEx(6, "&Item 6", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
    MenuItemEx(7, "Item &7", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)
    SetMenuExImageSize(32, 32)
    MenuTitleEx("&Big Icons")
    MenuItemEx(8, "&Item 8", $imagenormal[19], $imagehot[19], $imagedisabled[19], 0)
    MenuItemEx(9, "Item &9$\bCtrl+B", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
    MenuItemEx(10, "Item &10", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  ; attach our events callback for processing Windows ProGUI messages
  GUIRegisterMsg($WM_COMMAND, "ProGUI_EventCallback")

EndFunc


Open_Window_0() ; create window
GUISetState(@SW_SHOW) ; show our newly created window

; enter main event loop
Do

  $Event = GUIGetMsg()

Until $Event = $GUI_EVENT_CLOSE

