; Demonstrates the new $UISTYLE_OFFICE2007, $UISTYLE_OFFICE2003 User Interface styles

Global $Use64BitProGUI = False	; Use 64bit version of ProGUI (True/False)
#include <ProGUI_AutoIt.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>
#Include <Misc.au3>
#Include <GuiRichEdit.au3>
#Include <GuiComboBox.au3>

Func WindowWidth($hWnd)
    $rc = _WinAPI_GetClientRect($hWnd)
    Return DllStructGetData($rc, "right")-DllStructGetData($rc, "left")
EndFunc

Func WindowHeight($hWnd)
    $rc = _WinAPI_GetClientRect($hWnd)
    Return DllStructGetData($rc, "bottom")-DllStructGetData($rc, "top")
EndFunc


StartProGUI("", 0, 0, 0, 0, 0, 0, 0)


;- Control Constants
Enum $MENU_0, $MENU_1, $MENU_2, $MENU_3, $MENU_4, $MENU_5, $MENU_6, $MENU_7, $MENU_8, $MENU_9, $MENU_10, $MENU_11, $MENU_12, $MENU_13, $MENU_14, $MENU_15, $REBAR_0, $PopupMenu_0, $ContextMenu, $ContextMenu_1, $ContextMenu_2, $ContextMenu_3, $ContextMenu_4, $TOOLBAR_0, $TOOLBAR_1, $ExplorerBar, $Splitter

; Define some global arrays for easy access of icon images
Global $imageNormal[101]
Global $imageHot[101]
Global $imageDisabled[101]

Global $editor

;- Load Icons
$imagenormal[0] = LoadImg("icons\Office Icons\00139.ico", 16, 16, 0)
$imagenormal[1] = LoadImg("icons\Office Icons\01032.ico", 16, 16, 0)
$imagenormal[2] = LoadImg("icons\Office Icons\05965.ico", 16, 16, 0)
$imagenormal[3] = LoadImg("icons\Office Icons\01589.ico", 16, 16, 0)
$imagenormal[4] = LoadImg("icons\Office Icons\00178.ico", 16, 16, 0)
$imagenormal[5] = LoadImg("icons\Office Icons\06547.ico", 16, 16, 0)
$imagenormal[6] = LoadImg("icons\Office Icons\00762.ico", 16, 16, 0)
$imagenormal[7] = LoadImg("icons\Office Icons\09051.ico", 16, 16, 0)
$imagenormal[8] = LoadImg("icons\Office Icons\01714.ico", 16, 16, 0)
$imagenormal[9] = LoadImg("icons\Office Icons\00737.ico", 16, 16, 0)
$imagenormal[10] = LoadImg("icons\Office Icons\07226.ico", 16, 16, 0)
$imagenormal[11] = LoadImg("icons\Office Icons\00287.ico", 16, 16, 0)
$imagenormal[12] = LoadImg("icons\Office Icons\03621.ico", 16, 16, 0)
$imagenormal[13] = LoadImg("icons\Office Icons\00224.ico", 16, 16, 0)
$imagenormal[14] = LoadImg("icons\Office Icons\00285.ico", 16, 16, 0)
$imagenormal[15] = LoadImg("icons\Office Icons\07392.ico", 16, 16, 0)
$imagenormal[16] = LoadImg("icons\Office Icons\01707.ico", 16, 16, 0)
$imagenormal[17] = LoadImg("icons\Office Icons\02039.ico", 16, 16, 0)
$imagenormal[18] = LoadImg("icons\Office Icons\03739.ico", 16, 16, 0)
$imagenormal[19] = LoadImg("icons\Office Icons\05958.ico", 16, 16, 0)
$imagenormal[20] = LoadImg("icons\Office Icons\09276.ico", 16, 16, 0)
$imagenormal[21] = LoadImg("icons\Office Icons\02358.ico", 16, 16, 0)
$imagenormal[22] = LoadImg("icons\Office Icons\05905.ico", 16, 16, 0)
$imagenormal[23] = LoadImg("icons\Office Icons\03823.ico", 16, 16, 0)
$imagenormal[24] = LoadImg("icons\Office Icons\00018.ico", 16, 16, 0)
$imagenormal[25] = LoadImg("icons\Office Icons\00023.ico", 16, 16, 0)
$imagenormal[26] = LoadImg("icons\Office Icons\00003.ico", 16, 16, 0)
$imagenormal[27] = LoadImg("icons\Office Icons\00004.ico", 16, 16, 0)
$imagenormal[28] = LoadImg("icons\Office Icons\00109.ico", 16, 16, 0)
$imagenormal[29] = LoadImg("icons\Office Icons\00002.ico", 16, 16, 0)
$imagenormal[30] = LoadImg("icons\Office Icons\07387.ico", 16, 16, 0)
$imagenormal[31] = LoadImg("icons\Office Icons\00021.ico", 16, 16, 0)
$imagenormal[32] = LoadImg("icons\Office Icons\00019.ico", 16, 16, 0)
$imagenormal[33] = LoadImg("icons\Office Icons\00022.ico", 16, 16, 0)
$imagenormal[34] = LoadImg("icons\Office Icons\00108.ico", 16, 16, 0)
$imagenormal[35] = LoadImg("icons\Office Icons\00128.ico", 16, 16, 0)
$imagenormal[36] = LoadImg("icons\Office Icons\00129.ico", 16, 16, 0)
$imagenormal[37] = LoadImg("icons\Office Icons\01576.ico", 16, 16, 0)
$imagenormal[38] = LoadImg("icons\Office Icons\00916.ico", 16, 16, 0)
$imagenormal[39] = LoadImg("icons\Office Icons\00008.ico", 16, 16, 0)
$imagenormal[40] = LoadImg("icons\Office Icons\00142.ico", 16, 16, 0)
$imagenormal[41] = LoadImg("icons\Office Icons\00009.ico", 16, 16, 0)
$imagenormal[42] = LoadImg("icons\Office Icons\00016.ico", 16, 16, 0)
$imagenormal[43] = LoadImg("icons\Office Icons\00682.ico", 16, 16, 0)
$imagenormal[44] = LoadImg("icons\Office Icons\00931.ico", 16, 16, 0)
$imagenormal[45] = LoadImg("icons\Office Icons\01764.ico", 16, 16, 0)
$imagenormal[46] = LoadImg("icons\Office Icons\shapes.ico", 16, 16, 0)
$imagenormal[47] = LoadImg("icons\Office Icons\01031.ico", 16, 16, 0)
$imagenormal[48] = LoadImg("icons\Office Icons\04367.ico", 16, 16, 0)
$imagenormal[49] = LoadImg("icons\Office Icons\06717.ico", 16, 16, 0)
$imagenormal[50] = LoadImg("icons\Office Icons\00253.ico", 16, 16, 0)
$imagenormal[51] = LoadImg("icons\Office Icons\00779.ico", 16, 16, 0)
$imagenormal[52] = LoadImg("icons\Office Icons\00783.ico", 16, 16, 0)
$imagenormal[53] = LoadImg("icons\Office Icons\00782.ico", 16, 16, 0)
$imagenormal[54] = LoadImg("icons\Office Icons\03623.ico", 16, 16, 0)
$imagenormal[55] = LoadImg("icons\Office Icons\00144.ico", 16, 16, 0)
$imagenormal[56] = LoadImg("icons\Office Icons\05757.ico", 16, 16, 0)
$imagenormal[57] = LoadImg("icons\Office Icons\06094.ico", 16, 16, 0)
$imagenormal[58] = LoadImg("icons\Office Icons\00791.ico", 16, 16, 0)
$imagenormal[59] = LoadImg("icons\Office Icons\03743.ico", 16, 16, 0)
$imagenormal[60] = LoadImg("icons\Office Icons\01709.ico", 16, 16, 0)
$imagenormal[61] = LoadImg("icons\Office Icons\02041.ico", 16, 16, 0)
$imagenormal[62] = LoadImg("icons\Office Icons\00793.ico", 16, 16, 0)
$imagenormal[63] = LoadImg("icons\Office Icons\00790.ico", 16, 16, 0)
$imagenormal[64] = LoadImg("icons\Office Icons\06111.ico", 16, 16, 0)
$imagenormal[65] = LoadImg("icons\Office Icons\03727.ico", 16, 16, 0)
$imagenormal[66] = LoadImg("icons\Office Icons\04177.ico", 16, 16, 0)
$imagenormal[67] = LoadImg("icons\Office Icons\00794.ico", 16, 16, 0)
$imagenormal[68] = LoadImg("icons\Office Icons\00186.ico", 16, 16, 0)
$imagenormal[69] = LoadImg("icons\Office Icons\00184.ico", 16, 16, 0)
$imagenormal[70] = LoadImg("icons\Office Icons\01695.ico", 16, 16, 0)
$imagenormal[71] = LoadImg("icons\Office Icons\03631.ico", 16, 16, 0)
$imagenormal[72] = LoadImg("icons\Office Icons\02059.ico", 16, 16, 0)
$imagenormal[73] = LoadImg("icons\Office Icons\00798.ico", 16, 16, 0)
$imagenormal[74] = LoadImg("icons\Office Icons\00800.ico", 16, 16, 0)
$imagenormal[75] = LoadImg("icons\Office Icons\00107.ico", 16, 16, 0)
$imagenormal[76] = LoadImg("icons\Office Icons\00210.ico", 16, 16, 0)
$imagenormal[77] = LoadImg("icons\Office Icons\02626.ico", 16, 16, 0)
$imagenormal[78] = LoadImg("icons\Office Icons\03685.ico", 16, 16, 0)
$imagenormal[79] = LoadImg("icons\Office Icons\03688.ico", 16, 16, 0)
$imagenormal[80] = LoadImg("icons\Office Icons\03681.ico", 16, 16, 0)
$imagenormal[81] = LoadImg("icons\Office Icons\03683.ico", 16, 16, 0)
$imagenormal[82] = LoadImg("icons\Office Icons\00295.ico", 16, 16, 0)
$imagenormal[83] = LoadImg("icons\Office Icons\02166.ico", 16, 16, 0)
$imagenormal[84] = LoadImg("icons\Office Icons\02165.ico", 16, 16, 0)
$imagenormal[85] = LoadImg("icons\Office Icons\02164.ico", 16, 16, 0)
$imagenormal[86] = LoadImg("icons\Office Icons\03907.ico", 16, 16, 0)
$imagenormal[87] = LoadImg("icons\Office Icons\03908.ico", 16, 16, 0)
$imagenormal[88] = LoadImg("icons\Office Icons\03909.ico", 16, 16, 0)
$imagenormal[89] = LoadImg("icons\Office Icons\02068.ico", 16, 16, 0)
$imagenormal[90] = LoadImg("icons\Office Icons\02067.ico", 16, 16, 0)
$imagenormal[91] = LoadImg("icons\Office Icons\00984.ico", 16, 16, 0)
Global $crossImage = LoadImg("icons\Office Icons\cross.png", 0, 0, 0)

; simple example of how custom UI colours can be used
Func mixCustomColours($colour)

  $alpha = 50

  For $component = 0 To $MaxUIComponents-1

    ; if not menu background, menu dropshadow, item text, menu title text And $disabled colour components
    If $component <> $background And $component <> $menuDropShadow And $component <> $menuTextColor And $component <> $menuTitleTextColor And $component <> $disabledColor Then
      $c = GetUIColour($UISTYLE_WHIDBEY, $component, 0)
      $c = AlphaBlendColour($c, $colour, $alpha)
      SetUIColour($UISTYLE_WHIDBEY, $component, $c, GetCurrentColourScheme()+$UICOLOURMODE_CUSTOM, True) ; don't update

      $c = GetUIColour($UISTYLE_OFFICE2003, $component, 0)
      $c = AlphaBlendColour($c, $colour, $alpha)
      SetUIColour($UISTYLE_OFFICE2003, $component, $c, GetCurrentColourScheme()+$UICOLOURMODE_CUSTOM, True) ; don't update

      $c = GetUIColour($UISTYLE_OFFICE2007, $component, 0)
      $c = AlphaBlendColour($c, $colour, $alpha)
      If $component = $MaxUIComponents-1 Then
        SetUIColour($UISTYLE_OFFICE2007, $component, $c, GetCurrentColourScheme()+$UICOLOURMODE_CUSTOM, 0) ; update on last colour set
      Else
        SetUIColour($UISTYLE_OFFICE2007, $component, $c, GetCurrentColourScheme()+$UICOLOURMODE_CUSTOM, True) ; don't update
      EndIf
    EndIf

  Next

EndFunc

;- Process ProGUI Windows event messages here
Func ProGUI_EventCallback($hwnd, $message, $wParam, $lParam)

  Select

    ; handle selection of menu items And $toolbar items
    Case $message = $WM_COMMAND

      If HWord($wParam) = 0 Then ; is an ID Then

        $ID = LWord($wParam)

        ; handle checkboxes And $radiochecks
        If $ID >= 40 And $ID <= 44 Then
          SetMenuExItemState($MENU_0, $ID, BitOR($ItemEx_ShowRadiocheck, $ItemEx_UseIcon))
        EndIf
        If $ID = 45 Or $ID = 47 Then
          If GetMenuExItemState($MENU_0, $ID) = True Then
            SetMenuExItemState($MENU_0, $ID, False)
          Else
            SetMenuExItemState($MENU_0, $ID, $ItemEx_ShowCheckbox)
          EndIf
        EndIf
        If $ID = 52 Or $ID = 50 Then
          If GetMenuExItemState($MENU_0, $ID) = True Then
            SetMenuExItemState($MENU_0, $ID, False)
          Else
            SetMenuExItemState($MENU_0, $ID, BitOR($ItemEx_ShowCheckbox, $ItemEx_UseIcon))
          EndIf
        EndIf
        If $ID = 48 Or $ID = 49 Then
          If GetMenuExItemState($MENU_0, $ID) = True Then
            SetMenuExItemState($MENU_0, $ID, False)
          Else
            SetMenuExItemState($MENU_0, $ID, BitOR($ItemEx_ShowRadiocheck, $ItemEx_UseIcon))
          EndIf
        EndIf
        If $ID >= 55 And $ID <= 74 Then
          If GetMenuExItemState($MENU_3, $ID) = True Then
            SetMenuExItemState($MENU_3, $ID, False)
          Else
            SetMenuExItemState($MENU_3, $ID, $ItemEx_ShowCheckbox)
          EndIf
        EndIf
        If $ID = 168 Then
          If GetMenuExItemState($MENU_0, $ID) = True Then
            SetMenuExItemState($MENU_0, $ID, False)
            SetMenuItemEx($MENU_0, $ID, "Show &Gridlines", 0, 0, 0, 0)
          Else
            SetMenuExItemState($MENU_0, $ID, BitOR($ItemEx_ShowCheckbox, $ItemEx_UseIcon))
            SetMenuItemEx($MENU_0, $ID, "Hide &Gridlines", 0, 0, 0, 0)
          EndIf
        EndIf

        ; context menu
        If $ID = 210 Then
          $result = _ChooseFont(GetFontName(GetMenuExFont()), GetFontSize(GetMenuExFont()))
          If $result <> 0 Then
            $Font = LoadFontEx($result[2], $result[3], BitOr($result[1], $result[4]))
            SetMenuExFont($Font)
          EndIf
        ElseIf $ID = 228 Then
          SetMenuExItemState($ContextMenu_3, $ID, $ItemEx_ShowRadiocheck)
          SetToolBarExStyle($TOOLBAR_0, 0)
          SetRebarStyle($REBAR_0, 0)
        ElseIf $ID = 229 Then
          SetMenuExItemState($ContextMenu_3, $ID, $ItemEx_ShowRadiocheck)
          SetToolBarExStyle($TOOLBAR_0, $UISTYLE_OFFICE2003)
          SetRebarStyle($REBAR_0, $UISTYLE_OFFICE2003)
          SetMenuItemEx($ContextMenu, 208, "&Colour Theme", 0, 0, 0, $ContextMenu_1)
        ElseIf $ID = 230 Then
          SetMenuExItemState($ContextMenu_3, $ID, $ItemEx_ShowRadiocheck)
          SetToolBarExStyle($TOOLBAR_0, $UISTYLE_OFFICE2007)
          SetRebarStyle($REBAR_0, $UISTYLE_OFFICE2007)
          SetMenuItemEx($ContextMenu, 208, "&Colour Theme", 0, 0, 0, $ContextMenu_4)
        ElseIf $ID = 226 Then
          If GetMenuExItemState($ContextMenu, $ID) = False Then
            $txt = "Small example of custom user interface colours, choose a colour to mix the current theme with!"
            _GUICtrlRichEdit_AppendText($editor, $txt&@CRLF)

            $colour = _ChooseColor()
            If $colour <> -1 Then
              SetMenuExItemState($ContextMenu, $ID, True)
              mixCustomColours($colour)
            EndIf

            ; set User Interface colour mode to auto custom
            SetUIColourMode(GetCurrentColourScheme()+$UICOLOURMODE_CUSTOM)
          Else
            SetUIColourMode(GetCurrentColourScheme())
            SetMenuExItemState($ContextMenu, $ID, False)
          EndIf
        ElseIf $ID = 225 Then
          ShellExecute("http://www.progui.co.uk/register.html")
        EndIf
        Select
          ; theme colour radiocheck group
          Case $ID = 213
            SetMenuExItemState($ContextMenu_1, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu_4, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu, 226, False)
            SetUIColourMode($UICOLOURMODE_DEFAULT)
          Case $ID = 214
            SetMenuExItemState($ContextMenu_1, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu_4, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu, 226, False)
            SetUIColourMode($UICOLOURMODE_DEFAULT_BLUE)
          Case $ID = 215
            SetMenuExItemState($ContextMenu_1, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu_4, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu, 226, False)
            SetUIColourMode($UICOLOURMODE_DEFAULT_SILVER)
          Case $ID = 216
            SetMenuExItemState($ContextMenu_1, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu_4, 214, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu, 226, False)
            SetUIColourMode($UICOLOURMODE_DEFAULT_OLIVE)
          Case $ID = 217
            SetMenuExItemState($ContextMenu_1, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu_4, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExItemState($ContextMenu, 226, False)
            SetUIColourMode($UICOLOURMODE_DEFAULT_GREY)
          ; menu style radiocheck group
          Case $ID = 218
            SetMenuExItemState($ContextMenu_2, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExStyle($MENU_0, $UISTYLE_BUTTON)
          Case $ID = 219
            SetMenuExItemState($ContextMenu_2, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExStyle($MENU_0, $UISTYLE_EXPLORER)
          Case $ID = 220
            SetMenuExItemState($ContextMenu_2, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExStyle($MENU_0, $UISTYLE_MOZILLA)
          Case $ID = 221
            SetMenuExItemState($ContextMenu_2, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExStyle($MENU_0, $UISTYLE_BEVELED_A)
          Case $ID = 222
            SetMenuExItemState($ContextMenu_2, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExStyle($MENU_0, $UISTYLE_BEVELED_B)
          Case $ID = 223
            SetMenuExItemState($ContextMenu_2, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExStyle($MENU_0, $UISTYLE_WHIDBEY)
          Case $ID = 224
            SetMenuExItemState($ContextMenu_2, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExStyle($MENU_0, $UISTYLE_OFFICE2003)
          Case $ID = 227
            SetMenuExItemState($ContextMenu_2, $ID, $ItemEx_ShowRadiocheck)
            SetMenuExStyle($MENU_0, $UISTYLE_OFFICE2007)
        EndSelect

        ; display selected menu item in richedit control (with the exception of context menu)
        If $ID < 210 Or $ID > 226 Then
          $txt = "Menu item "&$ID&" selected."
          _GUICtrlRichEdit_AppendText($editor, $txt&@CRLF)
        EndIf

      EndIf

    ; resize richedit when rebar updated msg received
    Case $message = $REBAR_UPDATED

      _WinAPI_MoveWindow(SplitterExID($Splitter), 0, RebarHeight($REBAR_0), WindowWidth($Window_0), WindowHeight($Window_0)-RebarHeight($REBAR_0), True)

    ; resize richedit when window resizing
    Case $message = $WM_SIZE

      _WinAPI_MoveWindow(SplitterExID($Splitter), 0, RebarHeight($REBAR_0), WindowWidth($Window_0), WindowHeight($Window_0)-RebarHeight($REBAR_0), True)

    ; display right click context menu
    Case $message = $WM_RBUTTONDOWN

      DisplayPopupMenuEx($ContextMenu, $hwnd, MouseGetPos(0), MouseGetPos(1))

  EndSelect

  Return $GUI_RUNDEFMSG

EndFunc

;-
; creates a window
Func Open_Window_0()

  SetGlobalSkinColourTheme(GetDefaultGlobalSkinColourTheme())

  Global $Window_0 = GUICreate("Office Example", 800, 500, -1, -1, BitOR($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX))
  LimitWindowSize($Window_0, 350, 200, 0, 0)

  ;- *** Sub Menus ***
  ;- "Send To" Sub Menu
  CreatePopupMenuEx($MENU_1, $UISTYLE_OFFICE2007)
  MenuItemEx(31, "Mail Re&cipient (for Review)...", $imagenormal[19], 0, 0, 0)
  MenuItemEx(32, "M&ail Recipient (as Attachment)...", $imagenormal[18], 0, 0, 0)
  MenuItemEx(33, "&Routing Recipient...", $imagenormal[17], 0, 0, 0)
  MenuItemEx(34, "&Online Meeting Participant", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_1, 34, True)
  MenuItemEx(35, "Recipient using a &Fax Modem...", $imagenormal[16], 0, 0, 0)
  MenuItemEx(36, "Recipient using Internet Fa&x Service...", $imagenormal[15], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(37, "Microsoft Office &PowerPoint", $imagenormal[14], 0, 0, 0)

  ;- "Clear" Sub Menu
  CreatePopupMenuEx($MENU_2, $UISTYLE_OFFICE2007)
  MenuItemEx(38, "&Formats", 0, 0, 0, 0)
  MenuItemEx(39, "&Contents     Del", 0, 0, 0, 0)

  ;- "Toolbars" Sub Menu
  CreatePopupMenuEx($MENU_3, $UISTYLE_OFFICE2007)
  MenuItemEx(55, "Standard", 0, 0, 0, 0)
  SetMenuExItemState($MENU_3, 55, $ItemEx_ShowCheckbox)
  MenuItemEx(56, "Formatting", 0, 0, 0, 0)
  SetMenuExItemState($MENU_3, 56, $ItemEx_ShowCheckbox)
  MenuItemEx(57, "AutoText", 0, 0, 0, 0)
  MenuItemEx(58, "Control Toolbox", 0, 0, 0, 0)
  MenuItemEx(59, "Database", 0, 0, 0, 0)
  SetMenuExItemState($MENU_3, 59, $ItemEx_ShowCheckbox)
  MenuItemEx(60, "Drawing", 0, 0, 0, 0)
  MenuItemEx(61, "E-mail", 0, 0, 0, 0)
  MenuItemEx(62, "Forms", 0, 0, 0, 0)
  MenuItemEx(63, "Frames", 0, 0, 0, 0)
  MenuItemEx(64, "Mail Merge", 0, 0, 0, 0)
  MenuItemEx(65, "Outlining", 0, 0, 0, 0)
  MenuItemEx(66, "Picture", 0, 0, 0, 0)
  MenuItemEx(67, "Reviewing", 0, 0, 0, 0)
  SetMenuExItemState($MENU_3, 67, $ItemEx_ShowCheckbox)
  MenuItemEx(68, "Tables and Borders", 0, 0, 0, 0)
  MenuItemEx(69, "Task Pane", 0, 0, 0, 0)
  SetMenuExItemState($MENU_3, 69, $ItemEx_ShowCheckbox)
  MenuItemEx(70, "Visual Basic", 0, 0, 0, 0)
  MenuItemEx(71, "Web", 0, 0, 0, 0)
  MenuItemEx(72, "Web Tools", 0, 0, 0, 0)
  MenuItemEx(73, "Word Count", 0, 0, 0, 0)
  MenuItemEx(74, "Word Art", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(75, "&Customize", 0, 0, 0, 0)

  ;- "Reference" Sub Menu
  CreatePopupMenuEx($MENU_4, $UISTYLE_OFFICE2007)
  MenuItemEx(92, "Foot&note...", 0, 0, 0, 0)
  MenuItemEx(93, "&Caption...", 0, 0, 0, 0)
  MenuItemEx(94, "Cross-&reference...", 0, 0, 0, 0)
  MenuItemEx(95, "In&dex and Tables...", 0, 0, 0, 0)

  ;- "Picture" Sub Menu
  CreatePopupMenuEx($MENU_5, $UISTYLE_OFFICE2007)
  MenuItemEx(96, "&Clip Art...", $imagenormal[43], 0, 0, 0)
  MenuItemEx(97, "&From File...", $imagenormal[44], 0, 0, 0)
  MenuItemEx(98, "From &Scanner or Camera...", $imagenormal[45], 0, 0, 0)
  MenuItemEx(99, "&New Drawing", $imagenormal[42], 0, 0, 0)
  MenuItemEx(100, "&AutoShapes", $imagenormal[46], 0, 0, 0)
  MenuItemEx(101, "&WordArt...", $imagenormal[47], 0, 0, 0)
  MenuItemEx(102, "&Organization Chart", $imagenormal[48], 0, 0, 0)
  MenuItemEx(103, "C&hart", $imagenormal[49], 0, 0, 0)

  ;- "Frames" Sub Menu
  CreatePopupMenuEx($MENU_6, $UISTYLE_OFFICE2007)
  MenuItemEx(120, "&Table of Contents in Frame", $imagenormal[59], 0, 0, 0)
  MenuItemEx(121, "&New Frames Page", 0, 0, 0, 0)

  ;- "Language" Sub Menu
  CreatePopupMenuEx($MENU_7, $UISTYLE_OFFICE2007)
  MenuItemEx(139, "Set &Language...", $imagenormal[63], 0, 0, 0)
  MenuItemEx(140, "Tr&anslate...", $imagenormal[64], 0, 0, 0)
  MenuItemEx(141, "&Thesaurus...$Shift+F7", 0, 0, 0, 0)
  MenuItemEx(142, "&Hyphenation...", 0, 0, 0, 0)

  ;- "Online Collaboration" Sub Menu
  CreatePopupMenuEx($MENU_8, $UISTYLE_OFFICE2007)
  MenuItemEx(143, "&Meet Now", $imagenormal[65], 0, 0, 0)
  MenuItemEx(144, "&Schedule Meeting...", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_8, 144, True)
  MenuItemEx(145, "&Web Discussions", $imagenormal[66], 0, 0, 0)

  ;- "Letters and Mailings" Sub Menu
  CreatePopupMenuEx($MENU_9, $UISTYLE_OFFICE2007)
  MenuItemEx(146, "&Mail Merge...", 0, 0, 0, 0)
  MenuItemEx(147, "Show Mail Merge &Toolbar", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(148, "&Envelopes and Labels...", $imagenormal[67], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(149, "Letter Wi&zard...", 0, 0, 0, 0)

  ;- "Macro" Sub Menu
  CreatePopupMenuEx($MENU_10, $UISTYLE_OFFICE2007)
  MenuItemEx(150, "&Macros...$Alt+F8", $imagenormal[68], 0, 0, 0)
  MenuItemEx(151, "&Record New Macro...", $imagenormal[69], 0, 0, 0)
  MenuItemEx(152, "&Security...", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(153, "&Visual Basic Editor$Alt+F11", $imagenormal[70], 0, 0, 0)
  MenuItemEx(154, "Microsoft Script &Editor$Alt+Shift+F11", $imagenormal[71], 0, 0, 0)

  ;- "Insert" Sub Menu
  CreatePopupMenuEx($MENU_11, $UISTYLE_OFFICE2007)
  MenuItemEx(170, "&Table...", $imagenormal[39], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(171, "Columns to the &Left", $imagenormal[78], 0, 0, 0)
  MenuItemEx(172, "Columns to the &Right", $imagenormal[79], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(173, "Rows &Above", $imagenormal[80], 0, 0, 0)
  MenuItemEx(174, "Rows &Below", $imagenormal[81], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(175, "C&ells...", $imagenormal[82], 0, 0, 0)
  DisableMenuItemEx($MENU_11, 171, True)
  DisableMenuItemEx($MENU_11, 172, True)
  DisableMenuItemEx($MENU_11, 173, True)
  DisableMenuItemEx($MENU_11, 174, True)
  DisableMenuItemEx($MENU_11, 175, True)

  ;- "Delete" Sub Menu
  CreatePopupMenuEx($MENU_12, $UISTYLE_OFFICE2007)
  MenuItemEx(176, "&Table", 0, 0, 0, 0)
  MenuItemEx(177, "&Columns", $imagenormal[83], 0, 0, 0)
  MenuItemEx(178, "&Rows", $imagenormal[84], 0, 0, 0)
  MenuItemEx(179, "C&ells...", $imagenormal[85], 0, 0, 0)
  DisableMenuItemEx($MENU_12, 176, True)
  DisableMenuItemEx($MENU_12, 177, True)
  DisableMenuItemEx($MENU_12, 178, True)
  DisableMenuItemEx($MENU_12, 179, True)

  ;- "Select" Sub Menu
  CreatePopupMenuEx($MENU_13, $UISTYLE_OFFICE2007)
  MenuItemEx(180, "&Table", 0, 0, 0, 0)
  MenuItemEx(181, "&Column", 0, 0, 0, 0)
  MenuItemEx(182, "&Row", 0, 0, 0, 0)
  MenuItemEx(183, "C&ell", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_13, 180, True)
  DisableMenuItemEx($MENU_13, 181, True)
  DisableMenuItemEx($MENU_13, 182, True)
  DisableMenuItemEx($MENU_13, 183, True)

  ;- "AutoFit" Sub Menu
  CreatePopupMenuEx($MENU_14, $UISTYLE_OFFICE2007)
  MenuItemEx(184, "Auto&Fit to Contents", $imagenormal[86], 0, 0, 0)
  MenuItemEx(185, "AutoFit to &Window", $imagenormal[87], 0, 0, 0)
  MenuItemEx(186, "Fi&xed Column Width", $imagenormal[88], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(187, "Distribute Rows Eve&nly", $imagenormal[89], 0, 0, 0)
  MenuItemEx(188, "Distribute Columns Evenl&y", $imagenormal[90], 0, 0, 0)
  DisableMenuItemEx($MENU_14, 184, True)
  DisableMenuItemEx($MENU_14, 185, True)
  DisableMenuItemEx($MENU_14, 186, True)
  DisableMenuItemEx($MENU_14, 187, True)
  DisableMenuItemEx($MENU_14, 188, True)

  ;- "Convert" Sub Menu
  CreatePopupMenuEx($MENU_15, $UISTYLE_OFFICE2007)
  MenuItemEx(189, "Te&xt to Table...", 0, 0, 0, 0)
  MenuItemEx(190, "Ta&ble to Text...", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_15, 189, True)
  DisableMenuItemEx($MENU_15, 190, True)

  ;- *** Main Menu ***
  $menu = CreateMenuEx($MENU_0, $Window_0, $UISTYLE_OFFICE2007)
  ;- "File" Menu Title
  MenuTitleEx("&File")
  MenuItemEx(1, "&New...", $imagenormal[24], 0, 0, 0)
  MenuItemEx(2000, "&Open...$Ctrl+O", $imagenormal[25], 0, 0, 0)
  MenuItemEx(3, "&Close", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(4, "&Save$Ctrl+S", $imagenormal[26], 0, 0, 0)
  MenuItemEx(5, "Save &As...", 0, 0, 0, 0)
  MenuItemEx(6, "Save as Web Pa&ge...", $imagenormal[23], 0, 0, 0)
  MenuItemEx(7, "File Searc&h...", $imagenormal[22], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(8, "Ve&rsions...", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 8, 1)
  MenuBarEx()
  MenuItemEx(9, "We&b Page Preview", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 9, 1)
  MenuBarEx()
  MenuItemEx(10, "Page Set&up...", 0, 0, 0, 0)
  MenuItemEx(11, "Print Pre&view", $imagenormal[28], 0, 0, 0)
  MenuItemEx(12, "&Print...$Ctrl+P", $imagenormal[27], 0, 0, 0)
  DisableMenuItemEx($MENU_0, 12, 1)
  MenuBarEx()
  MenuItemEx(13, "Sen&d To", 0, 0, 0, MenuExID($MENU_1))
  MenuItemEx(14, "Propert&ies", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(15, "&1 Z:\\...\\My Documents\\test.doc", 0, 0, 0, 0)
  MenuItemEx(15, "&2 Z:\\...\\My Documents\\DCC Manager.doc", 0, 0, 0, 0)
  MenuItemEx(15, "&3 Z:\\...\\My Documents\\CV.doc", 0, 0, 0, 0)
  MenuItemEx(15, "&4 Z:\\...\\My Documents\\OperatingSystems.doc", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(15, "E&xit", 0, 0, 0, 0)

  ;- "Edit" Menu Title
  MenuTitleEx("&Edit")
  MenuItemEx(16, "Can't &Undo$Ctrl+Z", $imagenormal[35], 0, 0, 0)
  MenuItemEx(17, "Can't &Repeat$Ctrl+Y", $imagenormal[36], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(18, "Cu&t$Ctrl+X", $imagenormal[31], 0, 0, 0)
  MenuItemEx(19, "&Copy$Ctrl+C", $imagenormal[32], 0, 0, 0)
  MenuItemEx(20, "Office Clip&board...", $imagenormal[21], 0, 0, 0)
  MenuItemEx(21, "&Paste$Ctrl+V", $imagenormal[33], 0, 0, 0)
  MenuItemEx(22, "Paste &Special...", 0, 0, 0, 0)
  MenuItemEx(23, "Paste as &Hyperlink", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 23, True)
  MenuBarEx()
  MenuItemEx(24, "Cle&ar", 0, 0, 0, MenuExID($MENU_2))
  MenuItemEx(25, "Select A&ll", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(26, "&Find...$Ctrl+F", $imagenormal[20], 0, 0, 0)
  MenuItemEx(27, "R&eplace...", 0, 0, 0, 0)
  MenuItemEx(28, "&Go To...$Ctrl+G", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(29, "Lin&ks...", 0, 0, 0, 0)
  MenuItemEx(30, "&Object", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 29, True)
  DisableMenuItemEx($MENU_0, 30, True)

  ;- "View" Menu Title
  MenuTitleEx("&View")
  MenuItemEx(40, "&Normal", $imagenormal[13], 0, 0, 0)
  MenuItemEx(41, "&Web Layout", $imagenormal[12], 0, 0, 0)
  MenuItemEx(42, "&Print Layout", $imagenormal[11], 0, 0, 0)
  MenuItemEx(43, "&Reading Layout", $imagenormal[10], 0, 0, 0)
  MenuItemEx(44, "&Outline", $imagenormal[9], 0, 0, 0)
  SetMenuExItemState($MENU_0, 40, BitOR($ItemEx_ShowRadiocheck, $ItemEx_UseIcon))
  SetMenuExItemState($MENU_0, 41, BitOR($ItemEx_ShowRadiocheck, $ItemEx_UseIcon))
  SetMenuExItemState($MENU_0, 43, BitOR($ItemEx_ShowRadiocheck, $ItemEx_UseIcon))
  SetMenuExItemState($MENU_0, 44, BitOR($ItemEx_ShowRadiocheck, $ItemEx_UseIcon))
  SetMenuExItemState($MENU_0, 42, BitOR($ItemEx_ShowRadiocheck, $ItemEx_UseIcon, $ItemEx_EndRadiocheckGroup))
  MenuBarEx()
  MenuItemEx(45, "Tas&k Pane$Ctrl+F1", 0, 0, 0, 0)
  SetMenuExItemState($MENU_0, 45, $ItemEx_ShowCheckbox)
  MenuItemEx(46, "&Toolbars", 0, 0, 0, MenuExID($MENU_3))
  MenuItemEx(47, "Ru&ler", 0, 0, 0, 0)
  SetMenuExItemState($MENU_0, 47, $ItemEx_ShowCheckbox)
  MenuBarEx()
  MenuItemEx(48, "&Document Map", $imagenormal[8], 0, 0, 0)
  MenuItemEx(49, "Thum&bnails", $imagenormal[7], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(50, "&Header and Footer", $imagenormal[6], 0, 0, 0)
  MenuItemEx(51, "&Footnotes", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 51, True)
  MenuItemEx(52, "M&arkup", $imagenormal[5], 0, 0, 0)
  SetMenuExItemState($MENU_0, 52, BitOR($ItemEx_ShowCheckbox, $ItemEx_UseIcon))
  MenuBarEx()
  MenuItemEx(53, "F&ull Screen", $imagenormal[4], 0, 0, 0)
  MenuItemEx(54, "&Zoom...", 0, 0, 0, 0)

  ;- "Insert" Menu Title
  MenuTitleEx("&Insert")
  MenuItemEx(76, "&Break...", 0, 0, 0, 0)
  MenuItemEx(77, "Page N&umbers...", 0, 0, 0, 0)
  MenuItemEx(78, "Date and &Time...", 0, 0, 0, 0)
  MenuItemEx(79, "&AutoText", 0, 0, 0, 0)
  MenuItemEx(80, "&Field...", 0, 0, 0, 0)
  MenuItemEx(81, "&Symbol...", 0, 0, 0, 0)
  MenuItemEx(82, "Co&mment", $imagenormal[3], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(83, "Refere&nce", 0, 0, 0, MenuExID($MENU_4))
  MenuItemEx(84, "&Web Component...", $imagenormal[2], 0, 0, 0)
  DisableMenuItemEx($MENU_0, 84, True)
  MenuBarEx()
  MenuItemEx(85, "&Picture", 0, 0, 0, MenuExID($MENU_5))
  MenuItemEx(86, "Dia&gram...", $imagenormal[1], 0, 0, 0)
  MenuItemEx(87, "Te&xt Box", $imagenormal[0], 0, 0, 0)
  MenuItemEx(88, "Fi&le...", 0, 0, 0, 0)
  MenuItemEx(89, "&Object...", 0, 0, 0, 0)
  MenuItemEx(90, "Boo&kmark...", 0, 0, 0, 0)
  MenuItemEx(91, "Hyperl&ink...$Ctrl+K", $imagenormal[37], 0, 0, 0)

  ;- "Format" Menu Title
  MenuTitleEx("F&ormat")
  MenuItemEx(104, "&Font...", $imagenormal[50], 0, 0, 0)
  MenuItemEx(105, "&Paragraph...", $imagenormal[51], 0, 0, 0)
  MenuItemEx(106, "Bullets and &Numbering...", $imagenormal[52], 0, 0, 0)
  MenuItemEx(107, "&Borders and Shading...", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(108, "&Columns...", $imagenormal[41], 0, 0, 0)
  MenuItemEx(109, "&Tabs...", 0, 0, 0, 0)
  MenuItemEx(110, "&Drop Cap...", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 110, True)
  MenuItemEx(111, "Te&xt Direction...", $imagenormal[53], 0, 0, 0)
  DisableMenuItemEx($MENU_0, 111, True)
  MenuItemEx(112, "Change Cas&e...", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(113, "Bac&kground", 0, 0, 0, 0)
  MenuItemEx(114, "T&heme...", $imagenormal[54], 0, 0, 0)
  MenuItemEx(115, "F&rames", 0, 0, 0, MenuExID($MENU_6))
  MenuItemEx(116, "&AutoFormat...", $imagenormal[55], 0, 0, 0)
  MenuItemEx(117, "&Styles and Formatting...", $imagenormal[56], 0, 0, 0)
  MenuItemEx(118, "Re&veal Formatting...$Shift+F1", $imagenormal[57], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(119, "&Object...", $imagenormal[58], 0, 0, 0)
  DisableMenuItemEx($MENU_0, 119, True)

  ;- "Tools" Menu Title
  MenuTitleEx("&Tools")
  MenuItemEx(122, "&Spelling and Grammar...$F7", $imagenormal[29], 0, 0, 0)
  MenuItemEx(123, "&Research...$Alt+R", $imagenormal[30], 0, 0, 0)
  MenuItemEx(124, "&Language", 0, 0, 0, MenuExID($MENU_7))
  MenuItemEx(125, "&Word Count...", 0, 0, 0, 0)
  MenuItemEx(126, "A&utoSummarize...", $imagenormal[60], 0, 0, 0)
  MenuItemEx(127, "Speec&h", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(128, "Shared Wor&kspace...", 0, 0, 0, 0)
  MenuItemEx(129, "&Track Changes$Ctrl+Shift+E", $imagenormal[61], 0, 0, 0)
  MenuItemEx(130, "Compare and Merge &Documents...", 0, 0, 0, 0)
  MenuItemEx(131, "&Protect Document...", 0, 0, 0, 0)
  MenuItemEx(132, "O&nline Collaboration", 0, 0, 0, MenuExID($MENU_8))
  MenuBarEx()
  MenuItemEx(133, "L&etters and Mailings", 0, 0, 0, MenuExID($MENU_9))
  MenuBarEx()
  MenuItemEx(134, "&Macro", 0, 0, 0, MenuExID($MENU_10))
  MenuItemEx(135, "Templates and Add-&Ins...", 0, 0, 0, 0)
  MenuItemEx(136, "&AutoCorrect Options...", $imagenormal[62], 0, 0, 0)
  MenuItemEx(137, "&Customize...", 0, 0, 0, 0)
  MenuItemEx(138, "&Options...", 0, 0, 0, 0)

  ;- "Table" Menu Title
  MenuTitleEx("T&able")
  MenuItemEx(155, "Dra&w Table", $imagenormal[72], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(156, "&Insert", 0, 0, 0, MenuExID($MENU_11))
  MenuItemEx(157, "&Delete", 0, 0, 0, MenuExID($MENU_12))
  MenuItemEx(158, "Sele&ct", 0, 0, 0, MenuExID($MENU_13))
  MenuItemEx(159, "&Merge Cells", $imagenormal[73], 0, 0, 0)
  DisableMenuItemEx($MENU_0, 159, True)
  MenuItemEx(160, "S&plit Cells...", $imagenormal[74], 0, 0, 0)
  DisableMenuItemEx($MENU_0, 160, True)
  MenuItemEx(161, "Split &Table", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 161, True)
  MenuBarEx()
  MenuItemEx(162, "Table Auto&Format...", $imagenormal[75], 0, 0, 0)
  MenuItemEx(163, "&AutoFit", 0, 0, 0, MenuExID($MENU_14))
  MenuItemEx(164, "&Heading Rows Repeat", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 164, True)
  MenuBarEx()
  MenuItemEx(165, "Con&vert", 0, 0, 0, MenuExID($MENU_15))
  MenuItemEx(166, "&Sort...", $imagenormal[76], 0, 0, 0)
  MenuItemEx(167, "F&ormula...", 0, 0, 0, 0)
  MenuItemEx(168, "Hide &Gridlines", $imagenormal[77], 0, 0, 0)
  SetMenuExItemState($MENU_0, 168, BitOR($ItemEx_ShowCheckbox, $ItemEx_UseIcon))
  MenuBarEx()
  MenuItemEx(169, "Table P&roperties...", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 169, True)

  ;- "Window" Menu Title
  MenuTitleEx("&Window")
  MenuItemEx(191, "&New Window", 0, 0, 0, 0)
  MenuItemEx(192, "&Arrange All", 0, 0, 0, 0)
  MenuItemEx(193, "Compare Side &by Side with...", 0, 0, 0, 0)
  DisableMenuItemEx($MENU_0, 193, True)
  MenuItemEx(194, "&Split", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(195, "&1 Document1", 0, 0, 0, 0)
  SetMenuExItemState($MENU_0, 195, $ItemEx_ShowCheckbox)

  ;- "Help" Menu Title
  MenuTitleEx("&Help")
  MenuItemEx(196, "Microsoft Office Word &Help$F1", $imagenormal[91], 0, 0, 0)
  MenuItemEx(197, "Show the &Office Assistant", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(198, "&Microsoft Office Online", 0, 0, 0, 0)
  MenuItemEx(199, "&Contact Us", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(200, "Word&Perfect Help...", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(201, "Chec&k for Updates", 0, 0, 0, 0)
  MenuItemEx(202, "Detect and &Repair...", 0, 0, 0, 0)
  MenuItemEx(203, "Acti&vate Product...", 0, 0, 0, 0)
  MenuItemEx(204, "Customer &Feedback Options...", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(205, "&About Microsoft Office Word", 0, 0, 0, 0)

  ;- *** right click context menu ***
  ; 2003 colour themes
  CreatePopupMenuEx($ContextMenu_1, $UISTYLE_OFFICE2007)
  MenuItemEx(213, "&Automatic", 0, 0, 0, 0)
  MenuItemEx(214, "\c382d96\b&Blue", 0, 0, 0, 0)
  MenuItemEx(215, "\c7c7c94\b&Silver", 0, 0, 0, 0)
  MenuItemEx(216, "\c758d5e\b&Olive", 0, 0, 0, 0)
  MenuItemEx(217, "\c666666\bClassic &Grey", 0, 0, 0, 0)
  SetMenuExItemState($ContextMenu_1, 214, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_1, 215, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_1, 216, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_1, 217, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_1, 213, $ItemEx_ShowRadiocheck)
  ; 2007 colour themes
  CreatePopupMenuEx($ContextMenu_4, $UISTYLE_OFFICE2007)
  MenuItemEx(213, "&Automatic", 0, 0, 0, 0)
  MenuItemEx(214, "\c90b9ee\b&Blue", 0, 0, 0, 0)
  MenuItemEx(217, "\c67707c\bBl&ack", 0, 0, 0, 0)
  MenuItemEx(215, "\cb4b3c8\b&Silver", 0, 0, 0, 0)
  SetMenuExItemState($ContextMenu_4, 214, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_4, 215, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_4, 217, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_4, 213, $ItemEx_ShowRadiocheck)

  CreatePopupMenuEx($ContextMenu_3, $UISTYLE_OFFICE2007)
  MenuItemEx(228, "&Standard", 0, 0, 0, 0)
  MenuItemEx(229, "Office 200&3", 0, 0, 0, 0)
  MenuItemEx(230, "Office 200&7", 0, 0, 0, 0)
  SetMenuExItemState($ContextMenu_3, 228, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_3, 229, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_3, 230, $ItemEx_ShowRadiocheck)

  CreatePopupMenuEx($ContextMenu_2, $UISTYLE_OFFICE2007)
  MenuItemEx(218, "&Button", 0, 0, 0, 0)
  MenuItemEx(219, "&Explorer", 0, 0, 0, 0)
  MenuItemEx(220, "&Mozilla Firefox", 0, 0, 0, 0)
  MenuItemEx(221, "Beveled &1", 0, 0, 0, 0)
  MenuItemEx(222, "Beveled &2", 0, 0, 0, 0)
  MenuItemEx(223, "Office &XP/Whidbey", 0, 0, 0, 0)
  MenuItemEx(224, "Office 200&3", 0, 0, 0, 0)
  MenuItemEx(227, "Office 200&7", 0, 0, 0, 0)
  SetMenuExItemState($ContextMenu_2, 218, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_2, 219, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_2, 220, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_2, 221, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_2, 222, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_2, 223, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_2, 224, $ItemEx_ShowRadiocheck)
  SetMenuExItemState($ContextMenu_2, 227, $ItemEx_ShowRadiocheck)

  CreatePopupMenuEx($ContextMenu, $UISTYLE_OFFICE2007)
  MenuItemEx(208, "&Colour Theme", $imagenormal[54], 0, 0, $ContextMenu_4)
  MenuBarEx()
  MenuItemEx(209, "&Menu Style", 0, 0, 0, $ContextMenu_2)
  MenuItemEx(210, "&Font and Size...", $imagenormal[50], 0, 0, 0)
  MenuBarEx()
  MenuItemEx(212, "&Rebar and Toolbar Style", 0, 0, 0, $ContextMenu_3)
  MenuItemEx(226, "Custom Colours E&xample... (Choose a \b\c842059c\c10bf50o\c59aa10l\c345512o\caa2066u\c005f00r\n!)", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(225, "\c0000ff\uRegister Now!\n for a commercial license", 0, 0, 0, 0)

  ;/ create test popupmenu for toolbar $drop-$down
  $popupmenu = CreatePopupMenuEx($PopupMenu_0, $UISTYLE_OFFICE2007)
  MenuItemEx(206, "Test menu", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
  MenuItemEx(207, "Another one!", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  ;- create main toolbar
  $toolbar = CreateToolBarEx($TOOLBAR_0, $Window_0, 16, 16, BitOR($TBSTYLE_HIDECLIPPEDBUTTONS, $UISTYLE_OFFICE2007))
  ToolBarImageButtonEx(0, "", $imagenormal[24], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(1, "", $imagenormal[25], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(2000, "", $imagenormal[26], 0, 0, $BTNS_AUTOSIZE)
  ToolBarSeparatorEx()
  ToolBarImageButtonEx(3, "", $imagenormal[27], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(4, "", $imagenormal[28], 0, 0, $BTNS_AUTOSIZE)
  ToolBarSeparatorEx()
  ToolBarImageButtonEx(5, "", $imagenormal[29], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(6, "", $imagenormal[30], 0, 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECK))
  ToolBarSeparatorEx()
  ToolBarImageButtonEx(7, "", $imagenormal[31], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(8, "", $imagenormal[32], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(9, "", $imagenormal[33], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(10, "", $imagenormal[34], 0, 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECK))
  ToolBarSeparatorEx()
  ToolBarDropdownImageButtonEx(11, $popupmenu, "", $imagenormal[35], 0, 0, $BTNS_AUTOSIZE)
  ToolBarDropdownImageButtonEx(12, $popupmenu, "", $imagenormal[36], 0, 0, $BTNS_AUTOSIZE)
  ToolBarSeparatorEx()
  ToolBarImageButtonEx(13, "", $imagenormal[37], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(14, "", $imagenormal[38], 0, 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECK))
  ToolBarImageButtonEx(15, "", $imagenormal[39], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(16, "", $imagenormal[40], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(17, "", $imagenormal[41], 0, 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(18, "", $imagenormal[42], 0, 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECK))
  ToolBarSeparatorEx()
  ToolBarImageButtonEx(19, "", $imagenormal[8], 0, 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECK))

  $combo = _GUICtrlComboBox_Create($Window_0, "", 50, 300, 76, 22)
  _GUICtrlComboBox_AddString($combo, "500%")
  _GUICtrlComboBox_AddString($combo, "200%")
  _GUICtrlComboBox_AddString($combo, "150%")
  _GUICtrlComboBox_AddString($combo, "100%")
  _GUICtrlComboBox_AddString($combo, "75%")
  _GUICtrlComboBox_AddString($combo, "50%")
  _GUICtrlComboBox_AddString($combo, "25%")
  _GUICtrlComboBox_AddString($combo, "10%")
  _GUICtrlComboBox_AddString($combo, "Page Width")
  _GUICtrlComboBox_AddString($combo, "Text Width")
  _GUICtrlComboBox_AddString($combo, "Whole Page")
  _GUICtrlComboBox_AddString($combo, "Two Pages")

  $font = LoadFontEx(GetFontName(GetMenuExFont()), GetFontSize(GetMenuExFont()), 0)
  SetWindowFont($combo, $font)
  ToolBarExGadget(20, $combo, 0, 1, 0, 3, True)
  _GUICtrlComboBox_SetCurSel($combo, 3)

  ToolBarImageButtonEx(21, "", $imagenormal[91], 0, 0, $BTNS_AUTOSIZE)

  ;- disable some example buttons
  DisableToolbarExButton($toolbar, 7, True)
  DisableToolbarExButton($toolbar, 8, True)
  DisableToolbarExButton($toolbar, 9, True)
  DisableToolbarExButton($toolbar, 11, True)

  ;- some nice tooltips ;)
  ToolBarExToolTip($toolbar, 0, "New Blank Document")
  ToolBarExToolTip($toolbar, 1, "Open")
  ToolBarExToolTip($toolbar, 2000, "Save")
  ToolBarExToolTip($toolbar, 3, "Print (No Printer)")
  ToolBarExToolTip($toolbar, 4, "Print Preview")
  ToolBarExToolTip($toolbar, 5, "Spelling and Grammer")
  ToolBarExToolTip($toolbar, 6, "Research")
  ToolBarExToolTip($toolbar, 7, "Cut")
  ToolBarExToolTip($toolbar, 8, "Copy")
  ToolBarExToolTip($toolbar, 9, "Paste")
  ToolBarExToolTip($toolbar, 10, "Format Painter")
  ToolBarExToolTip($toolbar, 11, "Undo Typing")
  ToolBarExToolTip($toolbar, 12, "Can't Redo")
  ToolBarExToolTip($toolbar, 13, "Insert Hyperlink")
  ToolBarExToolTip($toolbar, 14, "Tables and Borders")
  ToolBarExToolTip($toolbar, 15, "Insert Table")
  ToolBarExToolTip($toolbar, 16, "Insert Microsoft Excel Worksheet")
  ToolBarExToolTip($toolbar, 17, "Columns")
  ToolBarExToolTip($toolbar, 18, "Drawing")
  ToolBarExToolTip($toolbar, 19, "Document Map")
  ToolBarExToolTip($toolbar, 21, "Microsoft Office Word Help")

  ;- create help toolbar containing ComboBox And $close button
  $helpToolbar = CreateToolBarEx($TOOLBAR_1, $Window_0, 16, 16, 0)
  $helpCombo = _GUICtrlComboBox_Create($Window_0, "", 50, 300, 180, 22)
  SetWindowFont($helpCombo, $font)
  _GUICtrlComboBox_SetCueBanner($helpCombo, "Type a question for help")
  ToolBarExGadget(300, $helpCombo, 0, 0, 0, 0, True)
  ToolBarImageButtonEx(301, "", $crossImage, 0, 0, 0)
  ToolBarExToolTip($toolbar, 301, "Close Window")

  ;- disable Windows 7/Vista fade effect of toolbar buttons
  DisableToolBarExButtonFade($toolbar)

  ;- create a rebar
  CreateRebar($REBAR_0, $Window_0, 0, BitOR($RBS_VARHEIGHT, $UISTYLE_OFFICE2007), 0)
  AddRebarGadget($menu, "", 0, 100, GetMenuExBarHeight($menu)-3, 0, BitOR($RBBS_BREAK, $RBBS_CHILDEDGE, $RBBS_GRIPPERALWAYS))
  AddRebarGadget($helpToolbar, "", 206, 206, 0, 0, BitOR($RBBS_NOGRIPPER, $RBBS_FIXEDSIZE))
  AddRebarGadget($toolbar, "", 0, 0, 0, 0, $RBBS_BREAK)

  ;- create richedit control
  $editor = _GUICtrlRichEdit_Create($Window_0, "", 0, RebarHeight($REBAR_0), WindowWidth($Window_0), WindowHeight($Window_0)-RebarHeight($REBAR_0))
  SetWindowFont($editor, $font)

  ;- add some example text to the richedit control
  $txt = Chr(10)&"Welcome to the Office Example!"&Chr(10)&Chr(10)
  $txt = $txt & "Try changing your theme colour settings (XP), menu font and size in order to see ProGUI automatically adapt."&Chr(10)
  $txt = $txt & "ProGUI components also implement smooth and fast rendering, try resizing the main window!"&Chr(10)&Chr(10)
  $txt = $txt & "Keyboard hot-keys/shortcuts are also created automatically based on the menu item text."&Chr(10)&Chr(10)
  $txt = $txt & "Right click anywhere in this RichEdit control for a context pop-up menu with various style settings."&Chr(10)
  _GUICtrlRichEdit_SetText($editor, $txt)

  ;- create example ExplorerBar
  CreateExplorerBar($Window_0, $ExplorerBar, 5, 5, 210, 490, $UISTYLE_OFFICE2007)
  AddExplorerBarGroup("System Tasks")
    ExplorerBarImageItem(0, "View system information", $imagenormal[0], 0, 0, 0)
    ExplorerBarImageItem(1, "Add or remove programs", $imagenormal[1], 0, 0, 0)
    ExplorerBarImageItem(2, "Change a setting", $imagenormal[2], 0, 0, 0)
  AddExplorerBarGroup("Other Places")
    ExplorerBarImageItem(3, "My Network Places", $imagenormal[3], 0, 0, 0)
    ExplorerBarImageItem(4, "My Documents", $imagenormal[4], 0, 0, 0)
    ExplorerBarImageItem(5, "Shared Documents", $imagenormal[5], 0, 0, 0)
    ExplorerBarImageItem(6, "Control Panel", $imagenormal[2], 0, 0, 0)
  AddExplorerBarGroup("Details")
    ExplorerBarItem(7, "Example Item 1")
    ExplorerBarItem(8, "Example Item 2")

  ;- create main splitter control
  SplitterEx($Window_0, $Splitter, 0, RebarHeight($REBAR_0), WindowWidth($Window_0), WindowHeight($Window_0)-RebarHeight($REBAR_0), $editor, ExplorerBarID($ExplorerBar), $UISTYLE_OFFICE2007, $SPLITTEREX_ANCHOREDRIGHT)
  SetSplitterExAttribute($Splitter, $SPLITTEREX_POSITION, 600)
  SetSplitterExAttribute($Splitter, $SPLITTEREX_SECONDMAXIMUMSIZE, 210)

  ; free loaded icons as we don't need them anymore
  For $n = 0 To 100
    FreeImg($imagenormal[$n])
    FreeImg($imagehot[$n])
    FreeImg($imagedisabled[$n])
  Next

  ; attach our events callback for processing Windows ProGUI messages
  GUIRegisterMsg($WM_COMMAND, "ProGUI_EventCallback")
  GUIRegisterMsg($WM_SIZE, "ProGUI_EventCallback")
  GUIRegisterMsg($REBAR_UPDATED, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_CLICK, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_HOVER, "ProGUI_EventCallback")

EndFunc


Open_Window_0() ; create window
GUISetState(@SW_SHOW) ; show our newly created window

;-
;- *** Enter main event loop ***
Do

  $Event = GUIGetMsg()

  If $Event = $GUI_EVENT_SECONDARYDOWN Then ; capture rightclick on editor Then
    ProGUI_EventCallback($Window_0, $WM_RBUTTONDOWN, 0, 0)
  EndIf

Until $Event = $GUI_EVENT_CLOSE
