; Demonstrates how to use TextControlEx's And $various styles

Global $Use64BitProGUI = False	; Use 64bit version of ProGUI (True/False)
#include <ProGUI_AutoIt.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>


StartProGUI("", 0, 0, 0, 0, 0, 0, 0)


Func WindowWidth($hWnd)
    $rc = _WinAPI_GetClientRect($hWnd)
    Return DllStructGetData($rc, "right")-DllStructGetData($rc, "left")
EndFunc

Func WindowHeight($hWnd)
    $rc = _WinAPI_GetClientRect($hWnd)
    Return DllStructGetData($rc, "bottom")-DllStructGetData($rc, "top")
EndFunc


;- process ProGUI Windows event messages here
Func ProGUI_EventCallback($hwnd, $message, $wParam, $lParam)

  Select

    ; handle selection of menu items
    Case $message = $WM_COMMAND

      If Hword($wParam) = 0 Then ; is an ID Then

        $MenuID = LWord($wParam)

        ConsoleWrite($MenuID&@CRLF) ; display selected menu item

      EndIf

    ; resize panelex when main window resized
    Case $message = $WM_SIZE

      _WinAPI_SetWindowPos(PanelExID(0, -1), 0, 0, 0, WindowWidth($Window_0), WindowHeight($Window_0), BitOR($SWP_NOCOPYBITS, $SWP_NOREDRAW, $SWP_NOOWNERZORDER))

    ; display a clicked link ID
    Case $message = $TCX_LINK_CLICK

      ConsoleWrite("Link "&$wParam&" Clicked!"&@CRLF)

  EndSelect

  Return $GUI_RUNDEFMSG

EndFunc

; creates a window
Func Open_Window_0()

  Global $Window_0 = GUICreate("TextControlEx Example", 800, 500, -1, -1, BitOR($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX))

  $font1 = LoadFontEx("Verdana", 10, 0)
  $font2 = LoadFontEx("Arial", 12, $Font_Bold)
  setTextControlExFont(-1, $font2, True)
  setTextControlExColour(-1, 0, MakeRGB(180, 180, 255))

  $img = LoadImg("icons\marble.png", 0, 0, 0)
  $Gradient = CreateGradient(0, MakeColour(180, 150, 167, 255), MakeColour(10, 228, 226, 255))

  CreatePanelEx(0, $Window_0, 0, 0, 800, 500, 0)
  AddPanelExImagePage(-1, $img, 0, 0, 0, 0, $PNLX_TILE)
  SetPanelExPageBackground(0, 0, $Gradient, $PNLX_IGNORE, $PNLX_IGNORE, $PNLX_IGNORE, $PNLX_IGNORE, $PNLX_IGNORE, $PNLX_OVERLAY, 0)

  SRandom(111)
  TextControlEx(PanelExID(0, 0), 0, Random(600), Random(300), 0, 0, "Bold text with coloured back fill and padding", BitOR($TCX_BK_FILL, $TCX_CENTRE))
  SetTextControlExPadding(0, 5, 5, 5, 5)
  SetTextControlExFont(-1, $font1, False)
  TextControlEx(PanelExID(0, 0), 1, Random(600), Random(300), 0, 0, "Some normal example text", 0)
  SetTextControlExColour(-1, MakeRGB(255, 0, 0), 0)
  TextControlEx(PanelExID(0, 0), 2, Random(600), Random(300), 0, 0, "Red example text", 0)
  SetTextControlExColour(-1, 0, 0)
  $Gradient = CreateGradient(0, MakeColour(255, 255, 255, 0), MakeColour(0, 0, 0, 255))
  SetTextControlExGradient(-1, $Gradient)
  TextControlEx(PanelExID(0, 0), 3, Random(600), Random(300), 300, 0, "Example text on alpha blend gradient background", $TCX_BK_GRADIENT)
  $text = "This is a multi-line\|\bTextControlEx\b with a \l123\c0000ffHyper Link\n\l\|and another \l1234\c0000ffHyper Link with Underline Hover\n|\c0000ff\uHyper Link with Underline Hover\n\l and some more text!"
  TextControlEx(PanelExID(0, 0), 4, Random(600), Random(300), 0, 0, $text, 0)

  ; attach our events callback for processing Windows ProGUI messages
  GUIRegisterMsg($WM_COMMAND, "ProGUI_EventCallback")
  GUIRegisterMsg($WM_SIZE, "ProGUI_EventCallback")
  GUIRegisterMsg($REBAR_UPDATED, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_CLICK, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_HOVER, "ProGUI_EventCallback")

EndFunc


Open_Window_0() ; create window
GUISetState(@SW_SHOW) ; show our newly created window

; enter main event loop
Do

  $Event = GUIGetMsg()

Until $Event = $GUI_EVENT_CLOSE
